/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Net.xs. Do not edit this file, edit Net.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Net.xs"
/*
  Copyright (c) 1996 Nick Ing-Simmons. All rights reserved.
  This program is free software; you can redistribute it and/or
  modify it under the same terms as Perl itself.
*/
#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#ifdef CAN_PROTOTYPE
#define NeedFunctionPrototypes 1
#define NeedNestedPrototypes 1
#else
#define NeedFunctionPrototypes 0
#define NeedNestedPrototypes 0
#endif

#include <audio/audiolib.h>
#include <audio/soundlib.h>

#include "../../Data/Audio.m"

AudioVtab     *AudioVptr;

#define AuFixedPointFromFloat(nnn) \
    ((AuInt32) ((nnn) * AU_FIXED_POINT_SCALE))


static void
done(AuServer *aud, AuEventHandlerRec *handler, AuEvent *ev,AuPointer data)
{
 switch (ev->auany.type)
  {
   case AuEventTypeElementNotify:
    {
     int *d = (int *) data;
     *d = (ev->auelementnotify.cur_state == AuStateStop);
     if (!*d || ev->auelementnotify.reason != AuReasonEOF)
      {
       fprintf(stderr, "curr_state=%d reason=%d\n",
               ev->auelementnotify.cur_state,
               ev->auelementnotify.reason);
      }
    }
    break;
   case AuEventTypeMonitorNotify:
    break;
   default:
    fprintf(stderr, "type=%d serial=%ld time=%ld id=%ld\n",
            ev->auany.type, ev->auany.serial, ev->auany.time, ev->auany.id);
    break;
  }
}

static void
AuDESTROY(AuServer *aud)
{
 AuFlush(aud);      
 AuCloseServer(aud);
}

void
AuPlay(AuServer *aud, Audio *au, float volume)
{
 int endian = 1;
#define little_endian ((*((char *)&endian) == 1))
 int priv = 0;
 AuEvent ev;
 STRLEN samp = Audio_samples(au);
 STRLEN na;
 Sound s = SoundCreate(SoundFileFormatNone,
                       little_endian ? AuFormatLinearSigned16LSB : AuFormatLinearSigned16MSB,
                       1, au->rate, samp, SvPV_nolen(au->comment)); 
 SV *tmp = Audio_shorts(au);
 if (!AuSoundPlayFromData(aud, s, (short *) SvPVX(tmp), AuNone,
                            AuFixedPointFromFloat(volume),
                            done, &priv,
                            NULL, NULL, NULL, NULL))
  {
   perror("problems playing data");
  }
 else
  {
   while (1)
    {
     AuNextEvent(aud, AuTrue, &ev);
     AuDispatchEvent(aud, &ev);
     if (priv)
      break;
    }
  }
 SvREFCNT_dec(tmp);
 SoundDestroy(s);
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 110 "Net.c"

XS(XS_Audio__Play__Net_Play); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Play__Net_Play)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::Play::Net::Play", "aud, au, vol = 0.5");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	AuServer *	aud;
	Audio *	au;
	float	vol;

	if (sv_isobject(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    aud = (AuServer *) tmp; 
	}
	else
	    croak("aud is not an object");

	if (sv_isobject(ST(1))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(1)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object");

	if (items < 3)
	    vol = 0.5;
	else {
	    vol = (float)SvNV(ST(2));
	}

	AuPlay(aud, au, vol);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__Play__Net_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Play__Net_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::Play::Net::DESTROY", "aud");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	AuServer *	aud;

	if (sv_isobject(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    aud = (AuServer *) tmp; 
	}
	else
	    croak("aud is not an object");

	AuDESTROY(aud);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__Play__Net_Flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Play__Net_Flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::Play::Net::Flush", "aud");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	AuServer *	aud;

	if (sv_isobject(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    aud = (AuServer *) tmp; 
	}
	else
	    croak("aud is not an object");

	AuFlush(aud);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__Play__Net_OpenServer); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Play__Net_OpenServer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::Play::Net::OpenServer", "class, server = NULL, proto = NULL, data = NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	class = (char *)SvPV_nolen(ST(0));
	char *	server;
	SV *	proto;
	SV *	data;
	AuServer *	RETVAL;

	if (items < 2)
	    server = NULL;
	else {
	    server = (char *)SvPV_nolen(ST(1));
	}

	if (items < 3)
	    proto = NULL;
	else {
	    proto = ST(2);
	}

	if (items < 4)
	    data = NULL;
	else {
	    data = ST(3);
	}
#line 121 "Net.xs"
 {
  STRLEN plen = 0;
  char *pstr  = (proto && SvOK(proto)) ? SvPV(proto,plen) : NULL;
  STRLEN dlen = 0;
  char *dstr  = (data && SvOK(data)) ? SvPV(data,dlen) : NULL;
  char *error = "Cannot open";
  RETVAL = AuOpenServer(server,plen,pstr,dlen,dstr,&error); 
  if (!RETVAL)
   croak("Error %s",error);
 }
#line 256 "Net.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::Play::Net", (void *) RETVAL);

    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Audio__Play__Net); /* prototype to pass -Wmissing-prototypes */
XS(boot_Audio__Play__Net)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Audio::Play::Net::Play", XS_Audio__Play__Net_Play, file);
        newXS("Audio::Play::Net::DESTROY", XS_Audio__Play__Net_DESTROY, file);
        newXS("Audio::Play::Net::Flush", XS_Audio__Play__Net_Flush, file);
        newXS("Audio::Play::Net::OpenServer", XS_Audio__Play__Net_OpenServer, file);

    /* Initialisation Section */

#line 135 "Net.xs"
 {
  AudioVptr = (AudioVtab *) SvIV(perl_get_sv("Audio::Data::AudioVtab",5));
 }

#line 293 "Net.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

